//+------------------------------------------------------------------+
//|                                                           TF.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include <MovingAverages.mqh>
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_plots   1
//--- plot tf
#property indicator_label1  "tf"
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrDarkOrange,clrDarkGreen,clrDeepSkyBlue,C'0,0,0',C'0,0,0',C'0,0,0',C'0,0,0',C'0,0,0'
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- input parameters
input int      periodSF=15;
input float    threshold=5;
//--- indicator buffers
double         tfBuffer1[];
double         tfBuffer2[];
double         tfBuffer3[];
double         tfBuffer4[];
double         tfColors[];
//custom variables
double ohlc[],SF[],D1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,tfBuffer1,INDICATOR_DATA);
   SetIndexBuffer(1,tfBuffer2,INDICATOR_DATA);
   SetIndexBuffer(2,tfBuffer3,INDICATOR_DATA);
   SetIndexBuffer(3,tfBuffer4,INDICATOR_DATA);
   SetIndexBuffer(4,tfColors,INDICATOR_COLOR_INDEX);
   SetIndexBuffer(5,ohlc,INDICATOR_CALCULATIONS);
   SetIndexBuffer(6,SF,INDICATOR_CALCULATIONS);
   SetIndexBuffer(7,D1,INDICATOR_CALCULATIONS);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//+------------------------------------------------------------------+
//| OHLC compute                             
//+------------------------------------------------------------------+
   for(int bar=0; bar<rates_total; bar++)
     {
      ohlc[bar]=(open[bar]+high[bar]+low[bar]+close[bar])/4;
     }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Shift back                             
//+------------------------------------------------------------------+
   for(int bar=0; bar<rates_total-periodSF; bar++)
     {
      ohlc[bar]=ohlc[bar+periodSF];
     }

   for(int bar=rates_total-periodSF; bar<rates_total; bar++)
     {
      ohlc[bar]=ohlc[rates_total-periodSF];
     }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Smooth OHLC                             
//+------------------------------------------------------------------+
   SimpleMAOnBuffer(rates_total,prev_calculated,0,periodSF,ohlc,SF);
   SimpleMAOnBuffer(rates_total,prev_calculated,0,periodSF,SF,SF);
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| TF compute                             
//+------------------------------------------------------------------+
   for(int bar=1; bar<rates_total; bar++)
     {
      D1[bar]=(SF[bar]-SF[bar-1])*100000;
      if(D1[bar]>threshold)
        {tfColors[bar]=0;}
      else if(D1[bar]<-threshold)
        {tfColors[bar]=2;}
      else
        {tfColors[bar]=1;}
     }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| TF draw                            
//+------------------------------------------------------------------+
   for(int bar=0; bar<rates_total; bar++)
     {
      tfBuffer1[bar]=open[bar];
      tfBuffer2[bar]=high[bar];
      tfBuffer3[bar]=low[bar];
      tfBuffer4[bar]=close[bar];
     }
//+------------------------------------------------------------------+

   return(rates_total);
  }
//+------------------------------------------------------------------+
